#include "DeerStudio/EditorEngine/API/FrameBuffer.h"
#include "DeerRender/FrameBuffer.h"

namespace Deer {
    namespace EditorEngine {

        int FrameBufferStruct::getWidth() {
            return FrameBufferManager::getFrameBufferWidth(frameBufferId);
        }

        int FrameBufferStruct::getHeight() {
            return FrameBufferManager::getFrameBufferWidth(frameBufferId);
        }

        void FrameBufferStruct::resize(int x, int y) {
            FrameBufferManager::resizeFrameBuffer(frameBufferId, x, y);
        }

        std::string FrameBufferStruct::getName() {
            return FrameBufferManager::getFrameBufferName(frameBufferId);
        }

        FrameBufferStruct createRGBA8FrameBuffer(std::string& name, int x, int y) {
            uint16_t id = FrameBufferManager::createRGBA8FrameBuffer(name, x, y);
            return FrameBufferStruct(id);
        }

        FrameBufferStruct getFrameBuffer(std::string& name) {
            return FrameBufferManager::getFrameBufferId(name);
        }
    }
}