#include "DeerStudio/EditorEngine/API/FrameBuffer.h"
#include "DeerStudio/EditorEngine/ErrorHandle.h"
#include "DeerStudio/EditorEngine.h"
#include "angelscript.h"

namespace Deer {
    namespace EditorEngine {
        void registerFrameBufferStructs() {
            AS_CHECK(scriptEngine->RegisterObjectType("FrameBuffer", sizeof(FrameBufferStruct), 
                asOBJ_VALUE | asOBJ_POD | asGetTypeTraits<FrameBufferStruct>() | asOBJ_APP_CLASS_ALLINTS));

        }

        void registerFrameBufferFunctions() {
            AS_CHECK(scriptEngine->RegisterObjectMethod(
                "FrameBuffer", "int get_width() const property",
                asMETHOD(FrameBufferStruct, getWidth), asCALL_THISCALL    
            ));

            AS_CHECK(scriptEngine->RegisterObjectMethod(
                "FrameBuffer", "int get_height() const property",
                asMETHOD(FrameBufferStruct, getHeight), asCALL_THISCALL    
            ));

            AS_CHECK(scriptEngine->RegisterObjectMethod(
                "FrameBuffer", "void resize(int, int)",
                asMETHOD(FrameBufferStruct, resize), asCALL_THISCALL    
            ));

            AS_CHECK(scriptEngine->RegisterObjectMethod(
                "FrameBuffer", "string get_name() const property",
                asMETHOD(FrameBufferStruct, getName), asCALL_THISCALL    
            ));

            AS_CHECK(scriptEngine->RegisterGlobalFunction(
                "FrameBuffer createRGBA8FrameBuffer(const string&in, int, int)",
                asFUNCTION(createRGBA8FrameBuffer),
                asCALL_CDECL
            ));

            AS_CHECK(scriptEngine->RegisterGlobalFunction(
                "FrameBuffer getFrameBuffer(const string&in)",
                asFUNCTION(getFrameBuffer),
                asCALL_CDECL
            ));
        }
    }
}